#include <sys/io.h>
#include <stdio.h>

#define D1	0x1
#define D2	0x2
#define D3	0x4
#define D4	0x8
#define D5	0x10
#define D6	0x20
#define D7	0x40
#define D8	0x80
#define PORT	0x378
#define ZGAS	outb(0, PORT)
#define WAIT	usleep(500000)
#define WAIT_M	usleep(100000)

int _a;
int diody[8] = {D1, D2, D3, D4, D5, D6, D7, D8};

#define GORA	for(_a=0; _a<8; _a++) { outb( diody[_a], PORT ); WAIT_M; }
#define DOL	for(_a=7; _a>=0; _a--) { outb( diody[_a], PORT ); WAIT_M; }

#define ROOT_LOGIN	for(_a=0; _a<10;_a++) { outb(0xFF, PORT); WAIT; outb(0, PORT); WAIT; }
#define SSHD_LOGIN	for(_a=0; _a<5;_a++) { outb(D4+D8, PORT); WAIT; outb(0, PORT); WAIT; }
#define FTPD_LOGIN	for(_a=0; _a<5;_a++) { outb(D3+D7, PORT); WAIT; outb(0, PORT); WAIT; }
#define AUTH_FAILURE	for(_a=0; _a<5;_a++) { outb(D1+D5, PORT); WAIT; outb(0, PORT); WAIT; }
#define POCZTA		for(_a=0; _a<5;_a++) { outb(D2, PORT); WAIT; outb(0, PORT); WAIT; }
#define WWW		outb(D1, PORT); WAIT; WAIT; outb(0, PORT); WAIT

#define PLIK	"sysek"

int main ( void )
{
    FILE *plik;
    int iii;
    char linia[101];

    while(1)
    {
    
	iopl(3);
	outb(0, PORT);

	plik = fopen(PLIK, "r");
    
	if( !plik )
	{
	    printf("Nie moge otworzyc pipki - sysek [%d]\n", plik);
	    printf("Zaloz pipefile: mkfifo sysek; chmod 600 sysek\n");
	    exit(0);
	}

	printf("Otwarta pipka [%d]\n", plik);

	while( fgets(linia, 100, plik) )
	{
	    printf("%s", linia);
	    
	    /* ktos loguje sie na roota!!!!! */
	    if( strstr(linia, "ROOT LOGIN") != 0 )
	    {
		ROOT_LOGIN;
		ZGAS;
	    }

	    /* ktos loguje sie na ssh */
	    if( strstr(linia, "sshd") != 0 )
	    {
		SSHD_LOGIN;
		ZGAS;
	    }

	    /* ktos nie mogl sie zalogowac :> */
	    if( strstr(linia, "authentication failure") != 0 )
	    {
		AUTH_FAILURE;
		ZGAS;
	    }
	    
	    /* www connection attempt from */
	    if( strstr(linia, "www connection attempt from") != 0 )
	    {
		WWW;
		ZGAS;
	    }
	    
	    /* port **** connection attempt from */
	    if( strstr(linia, "ippl: port") != 0&& strstr(linia, "connection attempt from") != 0 )
	    {
		GORA;
		DOL;
		ZGAS;
	    }

	    /* poczta do neutrinki */
	    if( strstr(linia, "jolach@jola.comm.pl") != 0 || strstr(linia, "@kwant.info") != 0 )
	    {
		POCZTA;
		ZGAS;
	    }

	}
	/* jesli by pipka padla to startuje sobie jeszcze raz :> */
    	sleep(5);
    }
}
